
#ifdef WIN32
#include <windows.h>
#endif


#include <string.h>
#include <stdio.h>

#define MAXPORTS 32
#define N_DRIVER_DATALENGTH 16384    // in units of words  (ie 4096 => 16 Kbyte)

#ifdef UNIX
#include <stdlib.h> /* getenv, exit */
#include <signal.h>
#include <errno.h>
#include <unistd.h>
#endif

extern "C" {
#include <sys/types.h>
}

int Tcp_Port[MAXPORTS];
int SocketConnected[MAXPORTS];
int TransferSize[MAXPORTS];
int Done[MAXPORTS];
char data_buffer[MAXPORTS][N_DRIVER_DATALENGTH*sizeof(int)];
int ReadEnable[MAXPORTS];
int ACKneeded [MAXPORTS];

int Stream[MAXPORTS];
int Length[MAXPORTS];
int Endian[MAXPORTS];

int ActivePorts;

#define TS_TCP_PORT 10305      // default port

void link_server();
void initialise_buffer_area();

int OutFlag =0;     /* no file output by default  */
FILE *OutStream;
char FileName[32];

int maxports=1;
int ts_tcp_port=TS_TCP_PORT;

int main(int argc, char *argv[], char *envp[])
{

   int i;

//    defaults for configuration information which may be supplied via the command line



//    echo command line arguments

   if (argc > 1) i = sscanf(argv[1],"%d", &maxports);
   if (argc > 2) i = sscanf(argv[2],"%d", &ts_tcp_port);

   if (argc > 3) {
       i = sscanf(argv[3],"%s",FileName);
       printf("Writing to %s\n",FileName);
       OutFlag = 1;
       OutStream = fopen(FileName,"w");
   }


   for (i=0; i<maxports; i++) {Tcp_Port[i] = ts_tcp_port+i; TransferSize[i] = 65536;}

   for (i=0; i<maxports; i++) {
      printf("Configuration: TCP port %d = %d\n", i, Tcp_Port[i]);
   }

   initialise_buffer_area();

   link_server();

#ifdef UNIX
   exit(0);
#endif

#ifdef WIN32
   ExitProcess(0);
#endif

   return(0);
}

