

if {![info exists ::DataAcquisition::PROJECT]} {
    namespace eval ::DataAcquisition {
         variable PROJECT; set PROJECT "MyProject"
    }
}


 proc DBGetValue {name} {
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode

       set Project $::DataAcquisition::PROJECT
       set Path [set ::[set Project]::DBRootName]/[set ::[set Project]::DBNodeBase]/[set ::[set Project]::DBNodeName]

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_get $Path $name} m]
        if {$rc != 0} {
            InsertLog "DB get returned with an error\n$m\n$errorCode\n$errorInfo"
#            set value "Error!"
             set value 0x0005dead
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                if {$LogFlag == 1} {InsertLog "$Path: $name = $m"}
                set value "$m"
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $name NOT available: error [second $m]; [third $m]"
#                set value "Error!"
                set value 0x0006dead
            }
        }
        return $value
  }

 proc DBSetValue {name vl} {
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode

#    do not allow parameters having the value 0xnnnndead to be stored   -    Use 0 lacking a better choice
      set value $vl
      if {$vl == 0x0005dead} {set value 0x0000}
      if {$vl == 0x0006dead} {set value 0x0000}
      if {$vl == 0x0007dead} {set value 0x0000}
      if {$vl == 0x0008dead} {set value 0x0000}
      if {$vl == 0x0000dead} {set value 0x0000}
      if {$vl == 0x0001dead} {set value 0x0000}
      if {$vl == 0x0002dead} {set value 0x0000}

       set Project $::DataAcquisition::PROJECT
       set Path [set ::[set Project]::DBRootName]/[set ::[set Project]::DBNodeBase]/[set ::[set Project]::DBNodeName]

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_set $Path $name "$value" "string"} m]
        if {$rc != 0} {
            InsertLog "DB set returned with an error\n$m\n$errorCode\n$errorInfo"
#            set value "Error!"
            set value 0x0007dead
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
                if {$LogFlag == 1} {InsertLog "$Path: $name = $m"}
                set value "$m"
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path $name NOT available: error [second $m]; [third $m]"
#                set value "Error!"
                set value 0x0008dead
            }
        }
        return $value
  }

  proc DBCreateNode {Path} {
       variable LogFlag
       global errorCode errorInfo
       global MIDAS_DataBaseCode

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_set $Path NULL NULL NULL} m]
        if {$rc != 0} {
            InsertLog "set returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode == 0} then {
#               InsertLog "$Path created/selected"
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path NOT created: error [second $m]; [third $m]"
            }
        }
  }

    proc DBGetNodes {Path Pattern} {
       variable LogFlag
        global errorCode errorInfo
        global MIDAS_DataBaseCode


        set nodeList {}

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_nodes $Path $Pattern} m]
        if {$rc != 0} {
            InsertLog "nodes returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_DataBaseCode >= 0} then {
                if {$MIDAS_DataBaseCode == 0} then {
                     if {$LogFlag == 1} {InsertLog "$Path contains nodes"}
                     set nodeList {}
                     foreach item $m {
                         lappend nodeList $item
                         if {$LogFlag == 1} {InsertLog "$item"}
                     }
                } else {
                     if {$LogFlag == 1} {InsertLog "$Path contains no nodes"}
                }
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:DataBaseAccessServer do_GetLastError} m]
                InsertLog "$Path access error: error [second $m]; [third $m]"
            }
        }
        return $nodeList
    }


