

    variable PROJECT $::DataAcquisition::PROJECT
    variable ACQSERVER $::DataAcquisition::ACQSERVER


   proc LoadOptions {} {
      variable PROJECT
      variable ACQSERVER

      set NodeBase [set ::[set PROJECT]::DBNodeBase]
      set ::[set PROJECT]::DBNodeBase "Options"

      set NodeName [set ::[set PROJECT]::DBNodeName]
      set ::[set PROJECT]::DBNodeName $ACQSERVER

      catch {unset ::Options}

      foreach item [split [DBGetValue Index] &&] {
         if {$item == ""} {continue}
         if {$item == "Index"} {continue}
         if {$item == "Error!"} {continue}
         set vl [DBGetValue $item]
         if {$vl != "Error!"} {set ::Options($item) $vl}
      }

      set ::[set PROJECT]::DBNodeBase $NodeBase
      set ::[set PROJECT]::DBNodeName $NodeName
   }

   proc SaveOptions {} {
      variable PROJECT
      variable ACQSERVER

      set NodeBase [set ::[set PROJECT]::DBNodeBase]
      set ::[set PROJECT]::DBNodeBase "Options"

      set NodeName [set ::[set PROJECT]::DBNodeName]
      set ::[set PROJECT]::DBNodeName $ACQSERVER

      set OptionList ""
      foreach item [array names ::Options] {
         if {$item == ""} {continue}
         if {$item == "Index"} {continue}
         if {$item == "Error!"} {continue}
         if {[string length $OptionList] > 0} {append OptionList "&&"}
         append OptionList "$item"
         DBSetValue "$item" [first [set ::Options($item)]]
      }
      DBSetValue Index $OptionList

#      InsertLog "Options saved to $NodeBase $NodeName"

      set ::[set PROJECT]::DBNodeBase $NodeBase
      set ::[set PROJECT]::DBNodeName $NodeName
   }


